%     VIRTUAL SORIC - программа для получения эффективных свойств заполнителей SORIC
%     Copyright (C) 2020  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Nodes_3D = Construct_Nodes_3D(Nodes_2D, N_EL_edge, RVE_Thickness, N_Elements_High, Shell_Layer, Shell_Layer_Thickness)

N_Nodes_2D = (N_EL_edge+1)^2*4+(2*(N_EL_edge+1)-1)^2 + 2*(2*(N_EL_edge+1)-1);

if (strcmp(Shell_Layer, 'TRUE'))
    
    N_Nodes_3D = N_Nodes_2D * (N_Elements_High + 3);
    
else
    
    N_Nodes_3D = N_Nodes_2D * (N_Elements_High + 1);
    
end

Nodes_3D = zeros(N_Nodes_3D, 4);

ind_1 = 0; %#ok<NASGU>
ind_2 = 0;

if (strcmp(Shell_Layer, 'TRUE'))
    
    ind_1 = ind_2 + 1;
    ind_2 = ind_1 - 1 + N_Nodes_2D;

    Nodes_3D(ind_1:ind_2,2:3) = Nodes_2D;
    Nodes_3D(ind_1:ind_2,4) = 0;
    
    for i=2:N_Elements_High + 2

        ind_1 = ind_2 + 1;
        ind_2 = ind_1 - 1 + N_Nodes_2D;

        Nodes_3D(ind_1:ind_2,2:3) = Nodes_2D;
        Nodes_3D(ind_1:ind_2,4) = Shell_Layer_Thickness + (RVE_Thickness-2*Shell_Layer_Thickness)*(i-2)/N_Elements_High;

    end
    
    ind_1 = ind_2 + 1;
    ind_2 = ind_1 - 1 + N_Nodes_2D;

    Nodes_3D(ind_1:ind_2,2:3) = Nodes_2D;
    Nodes_3D(ind_1:ind_2,4) = RVE_Thickness;
    
else

    for i=1:N_Elements_High + 1

        ind_1 = ind_2 + 1;
        ind_2 = ind_1 - 1 + N_Nodes_2D;

        Nodes_3D(ind_1:ind_2,2:3) = Nodes_2D;
        Nodes_3D(ind_1:ind_2,4) = RVE_Thickness*(i-1)/N_Elements_High;

    end

end

for i=1:N_Nodes_3D
    
    Nodes_3D(i,1) = i;
    
end
